<template>
  <div>
    trip run {{ index + 1 }} | trip duration:
    {{ durationFromSecondes(tripTotalDuration) }}
    | trip distance : {{ distanceFormatter(getStatistics?.distance) }}
    <div v-for="(stop, stationIndex) in model" :key="stop.id">
      <StationPoint
        v-model="model[stationIndex].station"
        :label="`station ${stationIndex + 1}`"
        :fromTime="calcFromTime(stationIndex)"
        :hasInTime="stationIndex != 0"
        :hasOutTime="stationIndex != model.length - 1"
        :shouldAddStopTime="stationIndex != 0"
      ></StationPoint>
      <div v-if="hasLeg(stationIndex)">
        duration :
        {{ legDuration(stationIndex) }}
        <br />
        distance :
        {{ legDistance(stationIndex) }}
      </div>
      <button
        v-if="showRemoveStopButton(stationIndex)"
        @click="handleRemoveStop(stop)"
      >
        Remove
      </button>
      <button v-if="showAddStopButton(stationIndex)" @click="handleAddStop">
        Add stop
      </button>
    </div>
  </div>
</template>

<script>
import StationPoint from './StationPoint.vue';
import { mapActions, mapGetters, mapMutations } from 'vuex';
import {
  isSameArray,
  durationFromSecondes,
  distanceFormatter,
} from '../shuttlingService';

export default {
  name: 'trip-path',
  components: { StationPoint },
  props: {
    fromTime: {
      type: [Number],
      default: 0,
    },
    index: {
      type: [String, Number],
      required: true,
    },
  },
  data: function () {
    return {
      nextStopId: 0,
      isRequesting: false,
      statistics: {
        distance: null,
        duration: null,
        legs: [],
      },
    };
  },
  methods: {
    ...mapActions('trips', ['calcTrip', 'removeExceededStations']),
    ...mapMutations('trips', [
      'addStop',
      'removeStop',
      'updateTripPath',
      'updateTripStatistics',
      'updateTripTotalTime',
      'updateStationTotalTime',
      'setIsTimingRunning',
    ]),
    handleAddStop() {
      this.nextStopId += 1;
      this.addStop({ nextStopId: this.nextStopId, index: this.index });
    },
    handleRemoveStop(stop) {
      this.removeStop({ index: this.index, stop });
    },
    hasLeg(index) {
      return (
        this.getStatistics &&
        this.getStatistics.legs &&
        this.getStatistics.legs.length > index
      );
    },
    showAddStopButton(stationIndex) {
      return stationIndex == this.model.length - 2;
    },
    showRemoveStopButton(stationIndex) {
      return stationIndex != 0 && stationIndex != this.model.length - 1;
    },
    calcFromTime(stationIndex) {
      if (stationIndex == 0) return this.fromTime;
      else {
        if (this.getStatistics) {
          let sum = this.getStatistics.legs.reduce((acc, cur, curIndex) => {
            if (stationIndex > curIndex) acc += cur.duration;
            return acc;
          }, this.fromTime);
          const stopTime = Math.max(stationIndex - 1, 0) * this.getStopDuration;

          return sum + stopTime;
        }
      }
    },
    durationFromSecondes,
    distanceFormatter,
  },
  computed: {
    ...mapGetters('trips', [
      'getTripByIndex',
      'isStillGenerate',
      'isProcessDone',
    ]),
    legDuration() {
      return (stationIndex) =>
        this.durationFromSecondes(
          this.statistics?.legs?.[stationIndex]?.duration
        );
    },
    legDistance() {
      return (stationIndex) =>
        distanceFormatter(this.statistics?.legs?.[stationIndex]?.distance);
    },
    ...mapGetters('config', ['getDurationBetweenTripRuns', 'getStopDuration']),
    tripTotalDuration() {
      if (!this.getStatistics) return '--';
      const stopCount = this.statistics?.legs?.length
        ? this.statistics?.legs?.length - 1
        : 0;
      const bRT = this.index == 0 ? 0 : this.getDurationBetweenTripRuns;
      return (
        this.getStatistics.duration + this.getStopDuration * stopCount + bRT
      );
    },
    getStatistics() {
      return this.getTripByIndex(this.index).statistics;
    },
    model: {
      get() {
        return this.getTripByIndex(this.index).trip;
      },
      set(path) {
        this.updateTripPath({ index: this.index, path });
      },
    },
    addresses() {
      return this.model.map(({ station }) => station?.location?.address);
    },
    allAddressesHasValue() {
      return this.addresses.filter((a) => !a).length == 0;
    },
    totalTimeDependencies() {
      const stopCount = this.statistics?.legs?.length
        ? this.statistics?.legs?.length - 1
        : 0;
      return (
        this.fromTime +
        (this.statistics?.duration || 0) +
        this.getStopDuration * stopCount +
        this.getDurationBetweenTripRuns
      );
    },
  },
  watch: {
    addresses: {
      async handler(val, oldVal) {
        if (
          this.model.length >= 2 &&
          this.allAddressesHasValue &&
          !this.isRequesting
        ) {
          if (isSameArray(val, oldVal)) return;
          this.isRequesting = true;
          this.statistics = await this.calcTrip(this.model);
          this.updateTripStatistics({
            index: this.index,
            statistics: this.statistics,
          });
          this.isRequesting = false;
        }
      },
      deep: true,
      immediate: true,
    },
    totalTimeDependencies: {
      handler() {
        if (this.statistics) {
          this.updateTripTotalTime({
            index: this.index,
            totalTime: this.totalTimeDependencies,
          });

          if (this.statistics)
            this.model.forEach((station, stationIndex) => {
              this.updateStationTotalTime({
                tripIndex: this.index,
                stationIndex,
                totalTime: this.calcFromTime(stationIndex),
              });
            });
        }
      },
      deep: true,
      immediate: true,
    },
    statistics: {
      deep: true,
      handler(val) {
        if (!val) {
          return;
        }
        this.setIsTimingRunning(true);
        this.model.forEach((station, stationIndex) => {
          this.updateStationTotalTime({
            tripIndex: this.index,
            stationIndex,
            totalTime: this.calcFromTime(stationIndex),
          });
        });
        this.setIsTimingRunning(false);
      },
    },
    isProcessDone: {
      handler(val) {
        if (val.done) this.removeExceededStations();
      },
      deep: true,
    },
  },
};
</script>

<style lang="scss" scoped></style>
